/* D2IO.H - chip rabinowitz & jim kyle - 08/30/86
 *	dos2 library header include file
 */

typedef struct ftb {
	int ugc;
	char mode;
	char hndl;
	char ercd;
} FILE;
extern	FILE	_ftb[20];

#define	RDBIT	1		/* bits of MODE byte */
#define	WRBIT	2
#define	RAWBIT	4
#define	EFBIT	8
#define	ERBIT	16
#define CRBIT	32
#define	DIRTY	128

#define	UGC	stream->ugc
#define	MODE	stream->mode
#define	HNDL	stream->hndl
#define	ERCD	stream->ercd

#define	stdin	(&_ftb[0])
#define	stdout	(&_ftb[1])
#define	stderr	(&_ftb[2])
#define	stdaux	(&_ftb[3])
#define	stdlst	(&_ftb[4])
#define	getchar()	fgetc(stdin)
#define	putchar(x)	fputc(x,stdout)
#define feof(stream)	((stream->mode&EFBIT)!=0)
#define ferror(stream)	((stream->mode&ERBIT)!=0)
#define clearerr(stream) (stream->mode &= ~(EFBIT | ERBIT))

#define hdl(x) ((unsigned)(x) - (unsigned)stdin)/sizeof(FILE)

#define NULL (void *)0
#define NULLP (char *)0
#define NIL 0
#define EOF -1

FILE *fopen(), *freopen();
FILE *fdopen();
long ftell();
